package enseirb.myinpulse.api;

import enseirb.myinpulse.api.datatypes.Project;
import enseirb.myinpulse.api.datatypes.ProjectDecision;

import enseirb.myinpulse.api.datatypes.Report;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.web.bind.annotation.*;

@SpringBootApplication
@RestController
public class AdminApi {

    /**
     * TODO
     *
     * @return a list of all project managed by the current admin user
     */
    @GetMapping("/admin/projects")
    public void getProjects() {}

    /**
     * TODO: Why in admin instead of shared ?
     *
     * @return a list of upcoming appointments for the current user
     */
    @GetMapping("/admin/appointments/upcoming")
    public void getUpcomingAppointments() {}

    /**
     * TODO
     *
     * @return a list of current unvalidated projects, waiting to be accepted
     */
    @GetMapping("/admin/projects/pending")
    public void getPendingProjects() {}

    /**
     * TODO
     *
     * <p>Endpoint used to make a decision about a project.
     *
     * @return the status code of the request
     */
    @PostMapping("/admin/projects/decision")
    public void validateProject(@RequestBody ProjectDecision decision) {}

    /**
     * TODO
     *
     * <p>Endpoint used to manually add a project by an admin
     *
     * @return the status code of the request
     */
    @PostMapping("/admin/project/add")
    public void addNewProject(@RequestBody Project project) {}

    /**
     * TODO: shouldn't it be an UPDATE request ?
     *
     * <p>Endpoint used to add a new report to an appointment
     *
     * @return the status code of the request
     */
    @PostMapping("/admin/appoitements/report/{appointmentId}")
    public void createAppointmentReport(
            @PathVariable String appointmentId, @RequestBody Report report) {}

    /**
     * TODO: Shouldn't a project be kept in history ? 2 different endpoints ?
     *
     * <p>Endpoint used to completely remove a project.
     *
     * @return the status code of the request
     */
    @DeleteMapping("/admin/projects/remove/{projectId}")
    public void deleteProject(@PathVariable String projectId) {}
}
